﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Http.Filters;
using MVCControlsToolkit.Controller;
using System.Collections; 
using System.Net.Http;
using System.Web.Http.Controllers;

namespace MVCControlsToolkit.ActionFilters
{
    public enum DateConversionFilterOperation { ToUTC, ToLocale, DeclareUTC, DeclareLocale }
    public class DateConversionFilterAttribute: ActionFilterAttribute
    {

        private DateConversionFilterOperation operation;
        public DateConversionFilterAttribute(DateConversionFilterOperation operation){
            this.operation = operation;
        }
        public override void OnActionExecuted(HttpActionExecutedContext actionExecutedContext)
        {
            HttpResponseMessage response = actionExecutedContext.Response;
            IEnumerable query;
             
            if (response != null && response.IsSuccessStatusCode && response.TryGetContentValue(out query) && query != null)
            {
                try
                {
                    List<object> res = new List<object>();
                    foreach (var x in query) res.Add(x);
                    switch (operation){
                        case DateConversionFilterOperation.ToUTC: ControllerUtilities.DatesToUTC(res); break;
                        case DateConversionFilterOperation.ToLocale: ControllerUtilities.DatesToLocale(res); break;
                        case DateConversionFilterOperation.DeclareUTC: ControllerUtilities.DeclareAllDatesKind(res, DateTimeKind.Utc); break;
                        case DateConversionFilterOperation.DeclareLocale: ControllerUtilities.DeclareAllDatesKind(res, DateTimeKind.Local); break;
                                
                    }
                    ControllerUtilities.DatesToUTC(res);
                   
                    actionExecutedContext.Response = actionExecutedContext.Request.CreateResponse(response.StatusCode, res);
                }
                catch (Exception ex)
                {
                    actionExecutedContext.Request.CreateResponse(System.Net.HttpStatusCode.InternalServerError, ex.Message);
                }
            }
            base.OnActionExecuted(actionExecutedContext);
        }
    }
}
